  var dialog_state = null;
  
  function DialogState() {
    this.dialogs = [];
    this.modal = [];
  }
  
  DialogState.dialog_state = function() {
    if (dialog_state === null) 
      dialog_state = new DialogState();
    return dialog_state;
  }
  
  DialogState.err = function() {
    if (dialog_state === null)
      return null;
    val =dialog_state.cur_dialog();
    if (!val)
      return null;
    return val.err;
  }
  
  DialogState.prototype.cur_dialog = function() {
    if (!this.dialogs.length)
      return null;
    return this.dialogs[this.dialogs.length - 1];
  }
  
  DialogState.prototype.add_modal = function(parent, func) {
    var curDialog = this.cur_dialog();
    var span_selector = "#" + parent + " * span";
    var input_selector = "#" + parent + " * input";
    curDialog.spans = $(span_selector);
    curDialog.inputs = $(input_selector);
    curDialog.func = func;
    curDialog.spans.css("pointer-events", "none");
    curDialog.inputs.prop("disabled", true);
  }

  DialogState.prototype.remove_modal = function(success, curDialog) {
    curDialog.spans.css("pointer-events", "auto");
    curDialog.inputs.prop("disabled", false);
    if (success === undefined)
      success = false;
    if (success && curDialog.func !== undefined)
      curDialog.func();
    if (success) {
      if (this.dialogs.length) 
         hide_dialog(null, true);
    }
  }

  DialogState.prototype.show_dialog = function(root, focusname) {
    var name = root+ "_dialog";
    var pageHeight = $(window).height();
    var pageWidth = $(window).width();
    var search = $("#" + name);
    var width = search.width();
    var height = search.height();
    var pos = {left: Math.floor((pageWidth - width)/2), 
      top: Math.floor((pageHeight - height) * 0.75) };
    var dialog = {cur: search, name:name, 
      err:document.getElementById(root + "_errorMsg")};
    reseterrors();
    search.offset(pos);
    setclass(search[0], name);
    this.dialogs.push(dialog);
    if (focusname !== undefined && focusname !== null)
      focus(focusname);
  }
  
  function show_dialog(root, focusname) {
    DialogState.dialog_state().show_dialog(root, focusname);
  }
  

  function show_modal_dialog(name, focusname, parent, func) {
    var state = DialogState.dialog_state();
    state.show_dialog(name, focusname);
    state.add_modal(parent, func);
    reseterrors();
  }
  
  DialogState.prototype.hide_dialog = function(event, success) {
    if (this.dialogs.length > 0) {
      var curDialog = this.dialogs.pop();
      setclass(curDialog.cur[0], curDialog.name + "_h");
      if (curDialog.spans)
        this.remove_modal(success, curDialog);
      }
  }
  
  function hide_dialog(event, success) {
    if (dialog_state === null)
      return null;
    DialogState.dialog_state().hide_dialog(event, success);
  }
  
  function setclass(obj, name) {
    obj.className = name;
  }
  
