  var destset = null; 			// textarea for search links
  var destsetnames = null;	// placeholder for set names
  var mergewarning = "";
  var defaultdwell = 180;
   
var initdoc = [
  [document, "ready", initui],
];

function initui() {
  setlinkdata(initlinkdata);
  setjquery(initdata);
}

var initdata = [
  ["#clearset1", "click", clearset1],
  ["#searchset1", "click", searchset1],
  ["#clearset2", "click", clearset2],
  ["#searchset2", "click", searchset2],
  ["#merge", "click", merge],
  ["#repeat", "change", fixhours],
  ["#pattern", "keypress", checksearch],
  ["#searchbutton", "click", searchfrequency],
  ["#clearsearch", "click", clearsearch],
  ["#hidesearchpane", "click", hidesearchpane],
  ["#importset1", "click", importset1],
  ["#importset2", "click", importset2],
  ["#import_cancel", "click", hide_dialog],
  ["#import_import", "click", do_import],
  ["#import_dialog", "keypress", import_keypress],
  ["#file_import", "change", import_clicked],
  ["#save", "click", show_save],
  ["#save_cancel", "click", hide_dialog],
  ["#save_save", "click", do_save],
  ["#save_name", "keypress", save_keypress],
  ["div[id^='titlebar_']", "mousedown", search_mousedown],
];

var initlinkdata = [
  ["closebutton", close_clicked],
];

function close_clicked(event) {
  hide_dialog(event);
}

function ok_clicked(event) {
  close_clicked(event);
}

// setlinkdata expects an array of 2 element array with values
//   [ 2 letter link name, click function ]
//   creates array of arrays for setjquery()
//   for the input array, 
//     ["ed", edit_clicked],
//   the following 3 arrays are created
//   [".a_ed", "click", edit_clicked],
//   [".s_ed", "mouseenter", toggletooltip],
//   [".s_ed", "mouseleave", toggletooltip],
function setlinkdata(linkdata) {
  var data = [];
  var i, j;
  for (i = 0; i < linkdata.length; i++) {
    var link = linkdata[i];
    var name = link[0];
    var clickfunc = link[1];
    var span_name = ".s_" + name;
    var anchor_name = ".a_" + name;
    var anchors;
    data.push([anchor_name, "click", clickfunc]);
    anchors = $(anchor_name);
    // add index to all the anchors for the clickfunc to use
    for (j = 0; j < anchors.length; j++) {
      anchors[j].fe_i = j;
    }
  }
  setjquery(data);
}

setjquery(initdoc);
  // setwarning - set mergewarning to str
  function setwarning(str) {
    mergewarning = str;
  }

  function appendfreqchange(oldfreq, freq) {
    if (mergewarning.length)
      mergewarning += ", ";
    else
      mergewarning = "Warning: "
    mergewarning += "replaced " + oldfreq + " with " + freq;
  }
  
  function checkwarning() {
    if (mergewarning.length)
      seterror(mergewarning);
  }

// reseterrors empties error message
function reseterrors() {
  mergewarning = "";
  seterror_safe("");
}

  // seterror_safe - print error message
  function seterror_safe(str) {
    var err = document.getElementById("errorMsg");
    err.classList.add("tderror");
    err.classList.remove("tdstatus");
    err.innerHTML = str;
  }

  // seterror - print error message, clear results
  function seterror(str) {
    seterror_safe(str);
    document.getElementById("results").value = "";
  }

  // seterror - print error message
  function setstatus(str) {
    var err = document.getElementById("errorMsg");
    err.classList.add("tdstatus");
    err.classList.remove("tderror");
    err.innerHTML = str;
  }

  // cleanup - remove preceding space and trailing whitespace and commas
  function cleanup(str) {
    return str.replace(/^[\s]*/g, "").replace(/[\s,]*$/g, "");
  }

  // clearset1 - empty the textarea of set1
  function clearset1() {
    var textarea = document.getElementById("set1");
    var names = document.getElementById("set1names");
    textarea.value = "";
    names.innerHTML = "&nbsp;";
  }

  // clearset2 - empty the textarea of set2
  function clearset2() {
    var textarea = document.getElementById("set2");
    var names = document.getElementById("set2names");
    textarea.value = "";
    names.innerHTML = "&nbsp;";
  }

  // cleanfreq if freq is not a simple frequency, remove the 
  //   other specifiers (dwell, sweep, waveform, etc
  function cleanfreq(freq) {
    var oldfreq;
    if (freq.search(/[ =-]/) < 0) 
      return freq;
    oldfreq = freq;
    if (freq.search(/ /) >= 0) {
      freq = freq.replace(/ .*$/, "");
    }
    if (freq.search(/=/) >= 0) {
      freq = freq.replace(/=.*$/, "");
    }
    if (freq.search(/-/) >= 0) {
      freq = freq.replace(/-.*$/, "");
    }
    appendfreqchange(oldfreq, freq);
    return freq;
  }
  
  // firstsmaller - merge sets when first set is smaller than the second set
  function firstsmaller(list1, list2) {
      var i;
      var list3 = new Array();
      list3.length = 0;
      for (i = 0; i < list2.length; i++) {
          var j = i % list1.length;
          list3.push(list1[j] + "f0c" + cleanfreq(list2[i]));
      }
      return list3;
  }

  // firstbigger - merge sets when first set is smaller than the second set
  function firstbigger(list1, list2) {
      var i;
      var list3 = new Array();
      
      list3.length = 0;
      for (i = 0; i < list1.length; i++) {
        var j = i % list2.length;
        list3.push(list1[i] + "f0c" + cleanfreq(list2[j]));
      }
      return list3;
  }


  // least_common_multiple - calc least common multiple
  function least_common_multiple(a, b) {
      var min, max, mult;
      var i;
      if (a < b) {
          min = a;
          max = b;
      } else {
          min = b;
          max = a;
      }
      mult = min * max;
      for (i = max; i <= mult; i += max) {
          if (!(i % min))
              return i;
      }
      return mult;
  }
  
  function dorepeat(list1, list2, maxtime) {
      var i;
      var len1 = list1.length;
      var len2 = list2.length;
      var nfreqs = least_common_multiple(len1, len2);
      var list3 = new Array();
      var duration = 0;
      list3.length = 0;
      for (i = 0; i < nfreqs; i++) {
        var i1 = i % len1;
        var i2 = i % len2;
        var str = "f0c";
        list3.push(list1[i1] + str + list2[i2]);
        duration += defaultdwell;
        if (maxtime > 0 && duration >= maxtime)
          break;
      }
      return list3;
  }
  
  function makeunique(list, hash) {
    var list1 = new Array();
    var i, len = list.length;
    list1.length = 0;
    for (i = 0; i < len; i++) {
      if (! hash[list[i]]) {
        var val = list[i];
        list1.push(val);
        hash[val] = 1;
      }
    }
    return list1;
  }
  
  function fixhours() {
    var hours_input = document.getElementById("hours");
    var hours_label = document.getElementById("hours_label");
    var repeat = document.getElementById("repeat");
    if (repeat.checked) {
      hours_input.disabled = false;
      hours_label.classList.add("td0");
      hours_label.classList.remove("td0_d");
    } else {
      hours_input.disabled = true;
      hours_label.classList.add("td0_d");
      hours_label.classList.remove("td0");
    }
  }
  
  function normalize(str) {
    var res = new Array();
    var list = str.split(",");
    var len = list.length;
    var i;
    for (i = 0; i < len; i++) {
      var s = list[i];
      if (s.includes("=")) {
        var parts = s.split("=");
        var freq = parts[0];
        var dwell = parseInt(parts[1]);
        var count = Math.ceil(dwell/defaultdwell);
        var j;
        if (count > 1 && freq.includes("-")) {
          var sweep = freq.split("-");
          var endfreq = parseFloat(sweep[1]);
          var startfreq = parseFloat(sweep[0]);
          var range = endfreq - startfreq;
          var delta = Math.round(1000 * (range / count)) / 1000;
          var newend = startfreq;
          for (j = 0; j < count; j++) {
              var newstart = newend;
              newend += delta;
              newend = Math.round(1000 * newend) / 1000;
              if (j == (count - 1))
                newend = endfreq;
              res.push(newstart + "-" + newend);
          }
        } else {
          for (j = 0; j < count; j++) {
            res.push(freq);
          }
        }
      } else {
        res.push(s);
      }
    }
    return res;
  }
  
  function getdwell() {
    var dwellinput = document.getElementById("dwell");
    var dwellstr = dwellinput.value;
    if (dwellstr.length == 0)
      defaultdwell = 180;
    else
      defaultdwell = parseInt(dwellstr);
    if (isNaN(defaultdwell)) {
      seterror("Dwell has an invalid value " + dwellstr);
    }
  }

  function get_maxtime() {
    var hoursinput = document.getElementById("hours");
    var hoursstr = hoursinput.value;
    var defaulthours = 0;
    if (hoursstr.length != 0)
      defaulthours = parseFloat(hoursstr);
    if (isNaN(defaulthours)) {
      seterror("hours has an invalid value " + hoursstr);
      return -1;
    }
    return defaulthours * 3600;
  }

  // merge the frequency sets found in set1 and set2 and
  //   place new frequency set into results
  function merge() {
    var textarea1 = document.getElementById("set1");
    var textarea2 = document.getElementById("set2");
    var results = document.getElementById("results");
    var repeat = document.getElementById("repeat").checked;
    var unique = document.getElementById("unique").checked;
    var s1 = cleanup(textarea1.value);
    var s2 = cleanup(textarea2.value);
    var list1, list2, list3;
    seterror("");
    setwarning("");
    getdwell();
    if (isNaN(defaultdwell)) {
      return;
    }
    if (s1.length == 0) {
      seterror("Set 1 is empty");
      return;
    }
    if (s2.length == 0) {
      seterror("Set 2 is empty");
      return;
    }
    if (s2.includes("-")) {
      seterror("Set 2 contains a sweep");
      return;
    }
    if (s1.includes("=")) {
      list1 = normalize(s1);
    } else {
      list1 = s1.split(",");
    }
    if (s2.includes("=")) {
      list2 = normalize(s2);
    } else {
      list2 = s2.split(",");
    }
    if (unique) {
      var hash = {};
      list1 = makeunique(list1, hash);
      list2 = makeunique(list2, hash);
    }
    if (repeat) {
      var maxtime = get_maxtime();
      if (maxtime < 0)
        return;
      list3 = dorepeat(list1, list2, maxtime); 
    } else {
      if (list1.length < list2.length) {
        list3 = firstsmaller(list1, list2);
      } else {
        list3 = firstbigger(list1, list2);
      }
    }
    checkwarning();
    results.value = list3.join(",");
    setstatus("Merged result has " + list3.length + " values.");
  }

  // searchset1 make the search pane visible, and destset to set1
  function searchset1() {
    var div1 = document.getElementById("searchpanel");
    var searchdest = document.getElementById("searchdest");
    hide_dialog(null, true);
    div1.style.visibility="visible";
    destset = document.getElementById("set1");
    destsetnames = document.getElementById("set1names");
    searchdest.innerHTML = "Clink link to add frequency set to Set 1";
  }

  // searchset2 make the search pane visible, and destset to set2
  function searchset2() {
    var div1 = document.getElementById("searchpanel");
    var searchdest = document.getElementById("searchdest");
    hide_dialog(null, true);
    div1.style.visibility="visible";
    destset = document.getElementById("set2");
    destsetnames = document.getElementById("set2names");
    searchdest.innerHTML = "Clink link to add frequency set to Set 2";
  }
  
  // checksearch check for enter key on search pattern field
  function checksearch(e) {
    if (e.keyCode == 13) {
      document.getElementById("searchbutton").click();
      return false;
    }
    return true;
  }

  // searchfrequency the frequency sets found in set1 and set2 and
  //   place new frequency set into results
  function searchfrequency() {
    var pattern = document.getElementById("pattern").value;
    var searchresults = document.getElementById("searchresults");
    var regex;
    var i;
    var resultval = "";
    seterror("");
    pattern = cleanup(pattern);
    if (pattern.length == 0) {
      seterror("Search pattern is empty.");
      return;
    }
    regex = new RegExp(pattern, "i");
    for (i = 0; i < frequencies.length; i++ ) {
        var element = frequencies[i];
        if ((element[0].search(regex) >= 0) ||
          (element[1].search(regex) >= 0)) {
          resultval += (
            "<a href=\"javascript:loadset(" + i + ")\">" +
            element[0] + "<\/a> <i>" + element[1] + "<\/i><br\/>") ;
        }
    }
    if (resultval.length == 0) {
      seterror("\"" + pattern + "\" not found");
    } else {
      searchresults.innerHTML = resultval;
    }
  }
  
function appendset(freqs, name) {
  if (destset.value === undefined || destset.value.length == 0) 
    destset.value = freqs;
  else
    destset.value += freqs;
  if (destsetnames.innerHTML == "&nbsp;") {
    destsetnames.innerHTML = name;
  } else {
    destsetnames.innerHTML += ", " + name;
  }
}
  
  // loadset called when search result links are clicked
  //   put frequency sets of link into the destset textarea
  //   append the set name to destsetnames <scan> tag
  function loadset(i) {
    if (destset == null) {
      seterror("No destination set specified");
      return;
    }
    appendset(frequencies[i][2], frequencies[i][0]);
  }
  
  // clearsearch clear search pattern text field, empty search results
  function clearsearch() {
    var pattern = document.getElementById("pattern");
    var searchresults = document.getElementById("searchresults");
    seterror("");
    pattern.value = "";
    searchresults.innerHTML = "";
  }

  // hidesearchpane make the search pane hidden
  function hidesearchpane() {
    var div1 = document.getElementById("searchpanel");
    div1.style.visibility="hidden";
    seterror_safe("");
  }

function import_keypress(event) {
  if (event.keyCode == 27) {
    hide_dialog(event);
    return false;
  }
  return true;
}

function setjquery(list) {
  var i, func, obj = null, arg;
  for (i = 0; i < list.length; i++) {
    var curItem = list[i];
    var newobj = $(curItem[0]);
    if (newobj != null)
      obj = newobj;
    func = obj[curItem[1]];
    arg = curItem[2];
    if (arg === null || arg === undefined)
      func.call(obj);
    else
      func.call(obj, arg);
  }
}

function show_save() {
  var results = document.getElementById("results");
  if (results.value.length == 0) {
    seterror("No frequencies in the Merged Set.");
    return;
  }
  set_save_error("&nbsp;");
  hidesearchpane();
  show_modal_dialog("save", "save_name", "main");
}

function show_import() {
  var file = $("#file_import");
  var target = file[0];
  if (target && target.files.length) {
    var data = [["#import_name", "val", target.files[0].name]];
    setjquery(data);
  }
  show_modal_dialog("import", "file_import", "main");
}

function importset1() {
    destset = document.getElementById("set1");
    destsetnames = document.getElementById("set1names");
    hidesearchpane();
    set_import_message("Frequencies will append to Set 1");
    show_import();
}

function importset2() {
    destset = document.getElementById("set2");
    destsetnames = document.getElementById("set2names");
    hidesearchpane();
    set_import_message("Frequencies will append to Set 2");
    show_import();
}

function do_import() {
  var event = {};
  event.target = $("#file_import")[0];
  import_clicked(event);
}

function import_clicked(event) {
  reseterrors();
  if (!event.target || !event.target.files.length) {
    seterror("No preset selected");
    return null;
  }
  open_preset(event);
  hide_dialog(event);
  return event;
}

// loaddata parse data textarea into user interface
function importdata(data) {
  var list;
  var i;
  var freqs, curfreqs;
  if (data.length == 0) {
    seterror("Data field is empty");
    return;
  }
  list = data.split("\r\n");
  freqs = new Array();
  for (i = 0; i < list.length; i++) {
    var str = list[i];
    var pos = str.search("\"Loaded_Frequencies=");
    if (pos == 0) {
      str = str.replace("\"Loaded_Frequencies=", "");
      str = str.replace(/[,]*\"$/g, "");
      curfreqs = str.split(",");
      freqs.push.apply(freqs, curfreqs);
    }
  }
  if (freqs.length == 0)
    seterror("No frequencies in " + cur_file_name);
  appendset(freqs.join(","), cur_file_name.replace(/.txt$/, ""));
  checkwarning();
}

var reader = null; // unfortunate global
var cur_file_name = null;

// reader_onload is a callback from the FileReader.readAsText()
function reader_onload() {
  var text = reader.result;
  importdata(text);
  reader = null;
}
  
  // open_preset reads the contents of a local file, in this case
  //   the Spooky2 preset file
function open_preset(event) {
  var input = event.target;
  reseterrors();    
  reader = new FileReader();
  reader._target = input;
  reader.onload = reader_onload;
  cur_file_name = input.files[0].name;
  reader.readAsText(input.files[0]);
}

// set_save_error - print error message
function set_save_error(str) {
  var err = document.getElementById("save_errorMsg");
  err.classList.add("tderror");
  err.classList.remove("tdstatus");
  err.innerHTML = str;
}

// set_save_error - print error message
function set_import_message(str) {
  var err = document.getElementById("import_errorMsg");
  err.classList.add("tdstatus");
  err.classList.remove("tderror");
  err.innerHTML = str;
}

function getfreqs() {
  var freqs = document.getElementById("results").value;
  var i;
  freqs = cleanup(freqs);
  var orig = freqs.split(",");
  var dwell = "=" + defaultdwell;
  var newfreqs = new Array();
  for (i = 0; i < orig.length; i++) {
    var pair = orig[i];
    if (pair.search(/f/i) >= 0) {
      pair = pair.replace(/f/i, dwell + "f");
    } else if (pair.search(/c/i) >= 0) {
      pair = pair.replace(/c/i, dwell + "c");
    } else {
      pair = pair.replace(/$/, dwell);
    }
    newfreqs.push(pair);
  }
  return newfreqs.join(",");
}

function getdata(preset_name, type) {
  var path = "broken";
  var dualout = "\"Out2_Square=True\"\r\n\"Inverse_Plus_Sync=False\"\r\n";
  switch (type) {
    case "Coil":
      path = "\\Shell (Empty) Presets\\Spooky Coil (XM Direct) - JW";
      dualout = "\"Out2_Sine=True\"\r\n\"Inverse_Plus_Sync=False\"\r\n";
      break;
    case "Contact":
      path = "\\Shell (Empty) Presets\\Contact\\Healing (C) - JW";
      break;
    case "Remote":
      path = "\\Shell (Empty) Presets\\Remote\\Healing (R) - JW";
      break;
    default:
      break;
  }
  var data = "\"[Preset]\"\r\n\"Base_Preset=" + path + "\"\r\n";
  
  data += "\"PresetName=" + preset_name + "\"\r\n" + dualout;
  data += "\"Preset_Notes=Notes for " + preset_name + " for "+type + "\"\r\n";
  data += "\"Loaded_Programs=" + preset_name + "\"\r\n";
  data += "\"Loaded_Frequencies=" + getfreqs() + "\"\r\n";
  data += "\"[/Preset]\"\r\n";
  return data;
}

  // data2blob converts the file contents into a blob (raw data) object
  function data2blob(data) {
    var blob=new Blob([data]);
    return blob;
  }
    
function do_save(event) {
  var preset_name = document.getElementById("save_name").value;
  var type = document.getElementById("preset_type").value;
  if (!preset_name.length) {
    set_save_error("Missing preset name");
    return;
  }
  var file_name = preset_name + ".txt";
  preset_name = preset_name.replace("\"", "'");
  var data = getdata(preset_name, type);
  saveAs(data2blob(data), file_name);
  hide_dialog(event, true);
}

var dragstate = {};
  
function find_dialog(target) {
  var parent = target;
  while (parent = parent.parentNode) {
    if (parent.id.search(/_dialog$/) > 0)
      return parent;
  }
  return null;
}

function search_mousedown(event) {
  var dialog = find_dialog(event.target);
  dialog = $(dialog);
  var bpos = dialog.offset();
  dragstate.deltaX = event.clientX - bpos.left;
  dragstate.deltaY = event.clientY - bpos.top;
  dragstate.dialog = dialog;
  document.addEventListener("mousemove", search_mousemove);
  document.addEventListener("mouseup", search_mouseup);
}

function search_mouseup(event) {
  search_mousemove(event);
  document.removeEventListener("mousemove", search_mousemove);
  document.removeEventListener("mouseup", search_mouseup);
}

function search_mousemove(event) {
  var dialog = dragstate.dialog;
  var bpos = {};
  bpos.left = event.clientX - dragstate.deltaX;
  bpos.top = event.clientY - dragstate.deltaY;
  dialog.offset(bpos);
}

function import_keypress(event) {
  if (event.keyCode == 27) {
    hide_dialog(event);
    return false;
  }
  return true;
}

function save_keypress(event) {
  if (event.keyCode == 13) {
    do_save(event);
    return false;
  }
  if (event.keyCode == 27) {
    hide_dialog(event);
    return false;
  }
  return true;
}

